/* Weapon.m -- implementation for Weapon objects
   Copyright (C) 1992, 1993 David A. Strout

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* Written by David Strout <dstrout@isi.edu>. */



#import "Weapon.h"

@implementation Weapon

/* This whole object was created so I could use a List to keep track instead of using Storage.  Since it's gonna be an object, alot more functionality ought to be in it, else we should eliminate it.  Oh well. */

- setFrom:(NXPoint *)thePoint
{
  from.x=thePoint->x;
  from.y=thePoint->y;
  return self;
}

-(NXPoint *)from
{
  return &from;
}

- setTo:(NXPoint *)thePoint
{
  to.x=thePoint->x;
  to.y=thePoint->y;
  return self;
}

- (NXPoint *)to
{
  return &to;
}

- setCurrent:(NXPoint *)thePoint
{
  current.x=thePoint->x;
  current.y=thePoint->y;
  return self;
}

- (NXPoint *)current
{
  return &current;
}


@end

