#import <appkit/View.h>

#define Martin1 0
#define Martin2 1
#define Ejk1 2
#define Ejk2 3
#define Nfunc 4    // The number of functions supported

#define Min(x,y) ((x < y)?x:y)
#define Max(x,y) ((x > y)?x:y)

#define Ranf() (double)((Ranfseed=(Ranfseed*1629+1)%1048576)/1048576.)
#define Ranfset(l) (Ranfseed=(((abs(l)%1048576)*1629)+1)%1048576)

#define	DEFAULTNUMCOLORS	14

#define	MAXDYNAMPOINTS	900   
#define	STARTDYNAMPOINTS	400

@interface MartinView:View
{
    int numPixels;			// number of pixels in buffer to be displayed 
	NXRect	*pixels;
	char	file[FILENAME_MAX];
	NXColor *colors, currColor;
    id  myPrefPanel;		// Preferences Panel
	id  smallInspect;       // Dummy inspector that shows up in the standard settings panel
	id	maxTotalPts;
	id	maxTotFlag;
	id	maxInRangePts;
	id	maxInFlag;
	id	dynamFlush;
	id	hopAField;
	id	hopBField;
	id	hopCField;
	id	seedPertInt;
	id	seedIntFlag;
	id	seedPertVal;
	id	seedValFlag;
	id	magField;
	id	magFlag;
	id	colInterval;
	id	colFlag;
	id	randomFlag;
	id	funcAuto;
	id	funcButton;
	id	colorButton;
	id	aFlag;
	id	bFlag;
	id	cFlag;
	id	a1Flag;
	id	b1Flag;
	id	c1Flag;
	id	afFlag;
	id	bfFlag;
	id	cfFlag;
	id	useFileFlag;
	id displaceX;
	id displaceY;

	int	Ncolors, Function;
	int     mxp, np;             /* max in-range points, in-range points    */
	int     mxP, nP;             /* max total points,    total points       */
	int     nC, nc;              /* color-change interval (points)          */
	int     nD, nd;       /* dynam flush buffer interval (points)    */
	int     Pn, pn;              /* seed perturbation interval (points)     */
	double  Pv;                    /* seed perturbation value                 */
	double  A, B, C;           /* hopalong parameters                     */
	int     Color;                 /* non-zero if color                       */
	int     Randomcolor;           /* non-zero for randomized color sequences */
	double  Zf;                    /* magnification factor                    */
	int 	cx, cy, ix, iy, mxX, mxY, W, H, moveX, moveY, color;
	double	 x, y, x1;
	long    Ranfseed;    	
	int		streamPos, isPaused;
 }

+ initialize;

- free;
- initFrame:(NXRect *)frameRect;
- sizeTo:(NXCoord)width :(NXCoord)height;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- windowWillMiniaturize:sender toMiniwindow:miniwindow;

/* Inherited from BackView */
- inspector:sender;
- inspectorWillBeRemoved;
- oneStep;
- (BOOL) useBufferedWindow;
- didLockFocus;

/* Inspector panel methods */
- pause:sender;
- useFile:sender;
- remember:sender;
- setHopA:sender;
- setHopB:sender;
- setHopC:sender;
- setMagnification:sender;
- setSeedInt:sender;
- setSeedVal:sender;
- setColChange:sender;
- setRandomColor:sender;
- setMaxTot:sender;
- setMaxIn:sender;
- setDisplacement:sender;
- changeColorMode:sender;
- convertColors;
- changeFunc:sender;
- changeDynam:sender;
- makeNewDynam:(int)num;
- newOne:sender;

@end


