#import "BackView.h"

@interface MovieShowView:BackView
{
	// movie frame specs
	const char *theMovie;
	id imageList;
	int currentFrame;
	int numberOfFrames;
	BOOL broken, running;
	
	// master control params
	int state;
	unsigned timeunit;
	unsigned wait, countdown;

	// frame timing control
	unsigned frametime;
	unsigned beginpause, endpause;
	unsigned darktime;

	// motion of "movie screen"
	NXPoint slideDelta;
	BOOL slideframes, slidebegin, slideend;
	BOOL jump;

	id inspectorPanel;
	id jumpButton;
	id slideFramesButton;
	id slidePausesButton;
	id filesTextField;
	id beginPauseTextField;
	id endPauseTextField;
	id darkForTextField;
	id timeUnitTextField;

	char *movieNameBuffer;
}

- oneStep;
- initFrame:(NXRect *)frameRect;
- initMovie;
- setImage:newImage;
- (BOOL)useBufferedWindow;
- slideImageRectOrigin;
- loadMovie;
- cacheMovie;
- getDefaults;

+ initialize;

- setJump:sender;
- setSlideFrames:sender;
- setSlidePauses:sender;
- setFile:sender;
- setBeginPause:sender;
- setEndPause:sender;
- setDarkFor:sender;
- setTimeUnit:sender;

@end

