#import <appkit/appkit.h>
#import "Thinker.h"
#import "StarShipProtocol.h"
#import "Warp1Common.h"
#import "Warp1Wraps.h"


#define MAXLINES 100	//max of  lines - start indices with 0


@interface Warp1:Object
{
        struct line{
		int toggle;
		float startDist;
		float dist1;
		float oldDist1;
		int delay;
		float theta;
	    float length;
		float oldLength;
		float r;
		float g;
		float b;
		int stopped;
	}lines[MAXLINES];  
	
	
	id starsObject;
	
	NXPoint				centerOfScreen;
	float				radius;
	
	BOOL				starsStopping;	//if starsObject has been told to stop
	BOOL				starsStopped;
	BOOL 				soundEnabled;
	float				starSpeed;
	int					starCounter;
	int					currentCycle;
	int					cycles;				//cycle slider value
	int					totalStopped;

	Sound *pwrDownSnd;
	Sound  *pwrUpSnd;

	
	
 	int					startInterval;		//how often to start

	float				objectSpeed;		//when creating next body

	NXRect		bounds;
    BOOL		firstState;
}

- init;
- setCenter;
- convertToXY:(float)dist :(NXPoint *)point :(float)theta;
- setFirstState;
- setStartInterval: (Slider *)sender;
- setObjectSpeed: (Slider *)sender;
- setStarSpeed:(Slider *)sender;
- setBoundsRect:(NXRect *)r;
- setStarsOutlet:(id)starsOutlet;
- eraseLine:(int)index;
- drawLine:(int)index;
- newLine:(int)index;
- newDist:(int)index;
@end
